// Author: Alexander Avilov
// Created: 09/17/92				Last Modification: 07/18/94
//
// Questions? You can find me at 75103,2032
//
// You can use this function free of charge. It's FREE. Also I can't garantee
// you anything. So you are going to use this function on you own risk.
//
// NOTE!!!! I assume that you do NOT use :cargo
// If you do use :cargo, you have the code that you can modify at any time and
// in any way.
//
// enjoy.
//
// Sanya


#include "scroll.ch"

Function setScrollKey( nI, nKey)
   Static __aUpDown__ := { 45, 43}         // key code for scrolling keys
                                           // by default they are "+" and "-"
   Local nOld := 0

   If ( nI > 0 .AND. nI < 3)
      nOld := __aUpDown__[nI]

      If ( !Empty( nKey) .AND. ValType( nKey) == "N")
         __aUpDown__[nI] := nKey
      Endif
   EndIf

Return( nOLd)



Procedure GetApplyMyKey( oGet, nKey, getList)
   Local nSelect  := Select()
   Local nRecNo
   Local nTmp
   Local nFieldPos
   Local coldOrder
   Local cOldCursor

   If ( (nKey == K_DEC       .OR. nKey == K_INC .OR. ;
         nKey == K_CTRL_HOME .OR. nKey == K_CTRL_END) .AND. ;
         (ValType( oGet:cargo) == "A" .AND. Len( oGet:cargo) == 3))

      If ( !Empty( ALIAS) .And. Select( ALIAS) > 0)   // to be sure that everything
         dbSelectArea( ALIAS)                         // is OK with dbf

         cOldOrder := ordSetFocus( ORDER)             // if ORDER is invalid
                                                      // ordSetFocus() will ignore it
      EndIf

      nRecNo := RecNo()                               // to restore old position later

      If ( (nFieldPos := fieldPos( FIELD)) > 0)       // nothing to do if this field
                                                      // does not exist
         If ( nKey == K_CTRL_HOME)
            dbGoTop()
         EndIf

         If ( nKey == K_CTRL_END)
            dbGoBottom()
         EndIf

         If ( lIndexed .AND. (nKey == K_DEC .Or. nKey == K_INC))
            If ( oGet:type <> "N")
               If (!dbSeek( AllTrim(oGet:buffer), .T.))  // i use softseek here to
                  dbGoTo( nRecNo)                        // eleminate typing errors
               EndIf
            Else
               If (!dbSeek( Val(oGet:buffer), .T.))  // i use softseek here to

                  dbGoTo( nRecNo)                        // eleminate typing errors
               EndIf
            Endif
         EndIf

         If ( nKey == K_DEC)
            nTmp := RecNo()
            dbSkip( -1)
         EndIf

         If ( nKey == K_INC)
            nTmp := RecNo()
            dbSkip()
         EndIf

         cOldCursor := SetCursor( 0)

         If ( !( EoF() .Or. BoF() ))
            // NOTE!!!! I assume that you do NOT use :cargo
            // If you do use :cargo or you do not need this feature,
            // comment '#define DO_REFRESH' in the "scroll.ch" NOW
            //
            // this loop is for updating variables with REFRESH FROM
            // in the @ Get command

            #ifdef DO_REFRESH
               For nTmp := 1 To Len( getList)
                  If ( valType( getList[nTmp]:cargo) == "A" .AND. ;
                        Len( getList[nTmp]:cargo) == 2       .AND. ;
                        (Empty(getList[nTmp]:cargo[1])       .Or.  ;    // always refresh.
                        Upper(getList[nTmp]:cargo[1]) == Upper(FIELD)); // refresh only
                     )                                                  // if FIELD
                     getList[nTmp]:varPut( Eval(getList[nTmp]:cargo[2]))
                     getList[nTmp]:changed := .T.
                     getList[nTmp]:display()
                  EndIf
               Next
            #endif

            oGet:buffer := Transform( fieldGet(nFieldPos), oGet:picture)
            oGet:changed := .T.
            oGet:display()
         Else
            dbGoTo( nTmp)
         EndIf

         SetCursor( cOldCursor)
      EndIF

      If ( lIndexed)
         dbGoTo( nRecNo)
      EndIf

      If ( !Empty( ALIAS) .And. Select( ALIAS) > 0)
         ordSetFocus( cOldOrder)
         dbSelectArea( nSelect)
      EndIf

   Else
      // lets clipper's getsys do the rest
      getApplyKey( oGet, nKey)
   EndIf

Return




PROCEDURE GetMyReader( oGet, getList)

   // Read the GET if the WHEN condition is satisfied
   IF ( GetPreValidate( oGet ) )

      // Activate the GET for reading
      oGet:setFocus()

      WHILE ( oGet:exitState == GE_NOEXIT )

         // Check for initial typeout (no editable positions)
         IF ( oGet:typeOut )
            oGet:exitState := GE_ENTER
         ENDIF

         // Apply keystrokes until exit
         WHILE ( oGet:exitState == GE_NOEXIT )
            GetApplyMyKey( oGet, inkey( 0 ), getList)       // The only changes
                                                            // in standard reader
         ENDDO

         // Disallow exit if the VALID condition is not satisfied
         IF ( !GetPostValidate( oGet ) )
            oGet:exitState := GE_NOEXIT
         ENDIF
      ENDDO

      // De-activate the GET
      oGet:killFocus()

   ENDIF

RETURN



